/* signal.h - This file is a part of NutsOS
 *
 * NutsOS
 * Copyright (C) 2013  Free Software Foundation, Inc.
 *
 * NutsOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * NutsOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with NutsOS; If not, see <http://www.gnu.org/licenses/>.
 *
 * Valentin Verdier <valentin.verdier03@gmail.com>
 */


#pragma once
#ifndef SIGNAL_H
#define SIGNAL_H

#include "process.h"

/* Du plus important au moins important */
#define SIGNAL_KILL 0
#define SIGNAL_TERM 1
#define SIGNAL_KCHILD 2

void SendSignal(unsigned int, T_Process*);
void ClearSignal(unsigned int, T_Process*);
unsigned int FetchSignal(unsigned int, T_Process*);

void HandleSignal(unsigned int, T_Process*);

#endif
